SoTextureCoordinatePlane(3)

NAME
SoTextureCoordinatePlane - The SoTextureCoordinatePlane class generates texture coordinates by projecting onto a plane.

SYNOPSIS

#include <Inventor/nodes/SoTextureCoordinatePlane.h>

Inherits SoTextureCoordinateFunction.

  Public Member Functions
virtual SoType getTypeId (void) const
SoTextureCoordinatePlane (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void pick (SoPickAction *action)
virtual void callback (SoCallbackAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFVec3f directionS
SoSFVec3f directionT
SoSFVec3f directionR

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoTextureCoordinatePlane ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoTextureCoordinatePlane class generates texture coordinates by projecting onto a plane. SoTextureCoordinatePlane is used for generating texture coordinates by projecting the object onto a texture plane. The s, t and r texture coordinates are computed as the distance from the origin to the projected point, in the respective directions. The texture plane is specified using two direction vectors, given as SoTextureCoordinatePlane::directionS and SoTextureCoordinatePlane::directionT in object space coordinates. SoTextureCoordinatePlane::directionR is used for generating the third coordinate, and can be used for generating texture coordinate for 3D textures. For 2D textures you can just leave this field alone.

The length of the vector determines the repeat interval of the texture per unit length.

A simple usage example:

SoSeparator *root = new SoSeparator;
root->ref();
// the texture image
SoTexture2 *tex = new SoTexture2;
tex->filename.setValue("foo.png");
root->addChild(tex);
// the texture plane
SoTextureCoordinatePlane *texPlane = new SoTextureCoordinatePlane;
texPlane->directionS.setValue(SbVec3f(1,0,0));
texPlane->directionT.setValue(SbVec3f(0,1,0));
root->addChild(texPlane);
// add a simple cube
SoCube * c = new SoCube;
c->width.setValue(1.0);
c->height.setValue(1.0)
c->depth.setValue(1.0);
root->addChild(new SoCube);

Here, we are projecting a texture onto a cube. The texture coordinate plane is specified by directionS = (1,0,0) and directionT = (0,1,0), meaning that it is parallel to the front face of the cube. Setting e.g. directionS = (0,1,0) and directionT = (-1,0,0) would rotate the texture counterclockwise by 90 degrees. Setting them to ((2,0,0), (0,2,0)) results to the texture being repeated twice per unit, so the texture appears four times on the 1x1 face.

Note that when you transform the cube, the transformation will also affect the texture - it will be transformed vs. the rest of the world, but appear 'fixed' on the object. If you want to change the placement of the texture on the object, you have to insert a SoTexture2Transform node before the texture coordinate plane. For instance in the example above, since the cube is centered in its coordinate system, the lower left corner of the texture appears to be in the middle of the face. To move the texture's origin to coincide with the lower left corner of the face, insert

SoTexture2Transform * tf = new SoTexture2Transform;
tf->translation.setValue(-0.5,-0.5);
root->addChild(tf);

before adding the texture coordinate plane.

FILE FORMAT/DEFAULTS:

TextureCoordinatePlane {
    directionS 1 0 0
    directionT 0 1 0
}

Constructor & Destructor Documentation

  SoTextureCoordinatePlane::SoTextureCoordinatePlane (void)
Constructor.

  SoTextureCoordinatePlane::~SoTextureCoordinatePlane () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoTextureCoordinatePlane::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoTextureCoordinatePlane::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoTextureCoordinateFunction.

  const SoFieldData ** SoTextureCoordinatePlane::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoTextureCoordinatePlane::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoTextureCoordinateFunction.

  void SoTextureCoordinatePlane::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoTextureCoordinatePlane::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoTextureCoordinatePlane::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoTextureCoordinatePlane::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Member Data Documentation

  SoSFVec3f SoTextureCoordinatePlane::directionS
The S texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

  SoSFVec3f SoTextureCoordinatePlane::directionT
The T texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

  SoSFVec3f SoTextureCoordinatePlane::directionR
The R texture coordinate plane direction. The length of the vector determines the repeat interval of the texture per unit length.

Author

Generated automatically by Doxygen for Coin from the source code.